cache:
  paths:
    - node_modules/

stages:
  - build
  - release

build:
  image: node:latest
  stage: build
  script:
    - |
      npm ci
      npm run build
  artifacts:
    paths:
      - dist/

release:
  image: docker:24.0.6-git
  stage: release
  services:
    - docker:24.0.6-dind
  variables:
    GITLAB_TOKEN: ${SEMANTIC_RELEASE_TOKEN}
    GITLAB_URL: ${CI_SERVER_URL}
    DOCKER_TLS_CERTDIR: "/certs"
    NODE_VERSION: "18.18.2"

  before_script:
    - |
      apk add --update nodejs
      apk add --no-cache jq curl
      curl -fsSLO --compressed "https://unofficial-builds.nodejs.org/download/release/v${NODE_VERSION}/node-v${NODE_VERSION}-linux-x64-musl.tar.xz"
      tar -xJf "node-v${NODE_VERSION}-linux-x64-musl.tar.xz" -C /usr/local --strip-components=1 --no-same-owner
      ln -sf /usr/local/bin/node /usr/local/bin/nodejs
  needs:
    - job: build
      artifacts: true

  script:
    - |
      npm ci
      npx semantic-release
